.Sh "TCEMP" "Getting started"
.Np NOTE
Before using \fItcemp\fP you should have set up your .xemprc as
described in "termc/xemprc".
.Np INVOCATION
You can call \fItcemp\fP just like the normal empire client,
although a few options are allowed. These options are described in
"termc/options". Normally you call tcemp as follows:
.sp 1
.Ti
$ tcemp <country> <password>
.sp 1
This will redump all information, like dump, lookout, radar, nukes, etc.
.sp 1
.Ti
$ tcemp -N <country> <password>
.IP
This will not redump anything. It won't connect to the empire-server,
so you can work (with buffered commands) even if the empire-server is
down.
.s1
As it will be your first time, just enter "tcemp <countryname>".
The program will ask you for your password, then connect to the
server and start to collect information.
.Np LAYOUT
There are four main windows:
.ne 5
.Sr
\(bu The census window
.br
\(bu The map window
.br
\(bu The message window
.br
\(bu The empire window
.Sl
.Np CENSUS
The census window will display all information about the current sector,
or if selected, about the current ship, plane or stockpile (nuke).
.s1
The census window can also contain some buttons for navigating ships,
showing info about starvation and work, recon with planes, etc.
.Np MAP
The map window shows your map. You can highlight sectors which satisfy
a certain condition, you can show the current designation or the new
designation, you can show some expression over the sector, etc, etc.
.Np MESSAGE
This window will be used for showing messages to you about what you
should do next, which button to use for which command, and asking
you questions about commands.
.Np EMPIRE
All the data sent to the server, and the output of the server are shown
in this window. You can also give commands here, but as this window
will be very small, this won't be very useful.
.Ph CURSOR
Using the keys 'hjkl' and 'HJKL', you can move your cursor around
the screen (just like vi). If you move off the screen, your cursor
will be placed at the other side of your screen.
.s1
By first pressing your \fBmove-prefix\fP key (default 'z', but you can set
this key in your .xemprc), followed by a move-char ('hjkl'), you can shift
the map. After pressing the move-prefix, the following keys will:
.Sr
.nf
\&'m' Move to the map window
.br
\&'c' Move to the census window
.br
\&'e' Move to the empire window
.br
\&'b' Move to the lower-left corner
.fi
.Sl
.Np COMMANDS
There are three ways in which you can give a command at a sector.
.sp 1
.Sr
\(bu At the census-window
.br
\(bu Through a menu
.br
\(bu Through a binding
.Sl
.Np CENSUS
When you select a place at the census window (eg with the space bar),
you can type in a new value (if appropiate). So if you want to
change the threshold of food in the current sector, go to the
census window and select the threshold column belonging to food.
.s1
You may now enter a new threshold, and \fItcemp\fP will feed the
correct command to the empire server (or buffer it, and feed it
later). You can change cutoff's, distribution paths, load a ship, etc,
etc. in the same way. As a deity, you're also allowed to change
resources and other quantities.
.Np MENU
If you press <Return> on a sector, you'll be given a pager with
commands you can give at this sector. Use 'jk' to select the
command you want to give.
.s1
If you press <Space> on a sector, the sector will become the
current sector.
.s1
If you press <Tab> at the map window, you'll be given a menu
with global commands.
.Np BINDING
If you press a key which is bound to a command, this command will
be executed (if possible).
.Sa "tcemp/buttons" "tcemp/pagers" "tcemp/bind"
